#include "StdAfx.h"

TSolution OptimizeBradford(const Matrix &_m)
{
    TSolution result;
    int flip = _m.H() > _m.W();
    Matrix m = (flip ? ~_m : _m);

    int *base = new int [m.H()];
    int *cols = new int [m.W()];
    int *flag = new int [m.W()];

    // . 1     
    for (int i = 0; i < m.H(); i++)
    {
        base[i] = 0;
        for (int j = 1; j < m.W(); j++)
            if (m(j,i) > m(base[i],i))
                base[i] = j;
    }

    // . 2  
    while(1)
    {
      //  -    
      for (int j = 0; j < m.W(); j++)
        cols[j] = 0;
      for (int i = 0; i < m.H(); i++)
        cols[base[i]]++;

      int optimal = 1;
      for (i = 0; i < m.H(); i++)
        if (cols[i] > 1)
        {
            optimal = 0;
            break;
        }
      if (optimal)
        break; //    

      // .3   ,   -
      //  ,    
      for ( j = 0; j < m.W(); j++)
        flag[j] = 0;
      int col_flag = 0;
      for ( j = 1; j < m.W(); j++)
        if (cols[j] > cols[col_flag])
            col_flag = j;
      flag[col_flag] = 1;

      int min_j_min;
      do
      {
        // .4  
        int* min_j = new int [m.H()];
        for (int i = 0; i < m.H(); i++)
          //      ?
          if (flag[base[i]])
          {
              // ,   ,  . 
              //  ,     
              //   ,     
              min_j[i] = -1;

              for (int j = 0; j < m.W(); j++)
                  if (!flag[j] && (min_j[i] == -1 || (m(base[i],i) - m(min_j[i],i)) > (m(base[i],i) - m(j,i))))
                      min_j[i] = j;
          }
          else min_j[i] = -1;

        min_j_min = -1;
        for ( i = 0; i < m.H(); i++)
          if (min_j[i] != -1 && (min_j_min == -1 || (m(base[min_j_min],min_j_min)-m(min_j[min_j_min],min_j_min)) > (m(base[i],i)-m(min_j[i],i))))
            min_j_min = i;

        double delta = m(base[min_j_min],min_j_min) - m(min_j[min_j_min],min_j_min);
        for (int j = 0; j < m.W(); j++)
          if (flag[j])
              for (int i = 0; i < m.H(); i++)
                  m(j,i) -= delta;

        //   
        flag[min_j[min_j_min]] = 1;
        //  
        cols[base[min_j_min]]--;
        base[min_j_min] = min_j[min_j_min];
        cols[base[min_j_min]]++;

        delete [] min_j;
      }
      // .4
      while (cols[base[min_j_min]] > 1);
    }

    //   (i, j)
     for ( i = 0; i < m.H(); i++)
	{
		if (flip)
		{
			if (_m(i,base[i])>0)
				result.push_back(TSolutionElement(i, base[i]));
		}
		else
		{
			if (_m(base[i],i)>0)
				result.push_back(TSolutionElement(base[i], i));
		}
	}
   /* for (i = 0; i < m.H(); i++)
        result.push_back(flip ? TSolutionElement(i, base[i]) : TSolutionElement(base[i], i));*/
	
    delete [] flag;
    delete [] cols;
    delete [] base;

    return result;
}