#include "stdafx.h"

int offset_x = 12;
int offset_y = 12;
int btn_width = 90;
int lst_height = 122;
int interval_x = 500;
int interval_y = 420;

void InitVisualization(CWnd *dialog)
{
    RECT dlg_rect;
    RECT button_rect;
    dialog->GetWindowRect(&dlg_rect);
    dialog->GetDlgItem(IDC_START)->GetWindowRect(&button_rect);
    btn_width = dlg_rect.right - button_rect.left;

    dialog->GetDlgItem(IDC_SDT)->GetWindowRect(&button_rect);
    lst_height = dlg_rect.bottom - button_rect.top;
}

void DrawRegion(CDC &dc, RECT window)
{
	RECT r;
	r.bottom = window.bottom - lst_height;
    r.top = offset_y;
    r.left = offset_x;
	r.right = window.right - btn_width;

	CBrush brush(RGB(0, 0, 0));
	dc.FillRect(&r, (CBrush*)&brush);
	brush.DeleteObject();
}

double GetX(double x)
{
	RECT rect;
	h_Dlg->GetClientRect(&rect);
	double k = (rect.right - offset_x - btn_width)/(2.*interval_x);
	return k*x + 0.5*(rect.right - btn_width + offset_x);
}

double GetY(double y)
{
	RECT rect;
	h_Dlg->GetClientRect(&rect);
	double k = (rect.bottom - offset_y - lst_height)/(2.*interval_y);
	return -k*y + 0.5*(rect.bottom - lst_height + offset_y);
}

double GetLengthX(double l)
{
	RECT rect;
	h_Dlg->GetClientRect(&rect);
	double k = (rect.right - offset_x - btn_width)/(2.*interval_x);
	return k*l;
}

double GetLengthY(double l)
{
	RECT rect;
	h_Dlg->GetClientRect(&rect);
	double k = (rect.bottom - offset_y - lst_height)/(2.*interval_y);
	return k*l;
}


void DrawRLS(CDC& dc)
{
	if(objects[1]->alive <= 0)return;
	//  
	CBrush br(RGB(0, 255, 0));
	double x = objects[1]->pos.x;
	double y = objects[1]->pos.y;
	dc.SelectStockObject(BLACK_PEN);
	dc.SelectObject(&br);
	dc.Ellipse( int( GetX(x) )-3, int( GetY(y) )-3, int( GetX(x) )+3, int( GetY(y) )+3 );
	br.DeleteObject();
	//  
	RECT rect;
	rect.bottom = LONG( GetY(RLSTTX.r) );
	rect.top = LONG( GetY(-RLSTTX.r) );
	rect.left = LONG( GetX(-RLSTTX.r) );
	rect.right = LONG( GetX(RLSTTX.r) );

	POINT start;
	start.x = LONG( GetX(0) );
	start.y = LONG( GetY(0) );

	CPen pen, *def_pen;
	pen.CreatePen(PS_SOLID, 1, RGB(0, 255, 0));
	def_pen = dc.SelectObject(&pen);
	dc.Arc(&rect, start, start);
	pen.DeleteObject();
	

	br.CreateSolidBrush(RGB(0, 48, 0));
	dc.SelectObject(&br);
	dc.FloodFill( int( GetX(-20) ), int( GetY(0) ), RGB(0, 255, 0));
	dc.Arc(&rect, start, start);
	br.DeleteObject();
	dc.SelectObject(def_pen);
}

void DrawObject(CDC &dc)
{
	if(objects[0]->alive <= 0)return;
	CBrush br(RGB(0, 128, 0)), *def_br;
	CPen pen, *def_pen;
	pen.CreatePen(PS_SOLID, 1, RGB(0, 255, 0));
	double x = objects[0]->pos.x;
	double y = objects[0]->pos.y;

	RECT rect;
	rect.top = LONG( GetY(y)-4 );
	rect.bottom = LONG( GetY(y)+ 4 );
	rect.left = LONG( GetX(x)-4 );
	rect.right = LONG( GetX(x)+4 );
	def_br = dc.SelectObject(&br);
	def_pen = dc.SelectObject(&pen);
//	dc.SetDCPenColor(RGB(255, 0, 0));
	dc.Rectangle(&rect);
	br.DeleteObject();
	pen.DeleteObject();
	dc.SelectObject(def_br);
	dc.SelectObject(def_pen);
}

void DrawZRK(CDC &dc)
{
	CBrush br;
	CBrush *def_br;
	CPen pen;
	CPen *def_pen;
	RECT rect;
	double a, g;
	double x, y, r;
	POINT start;
	POINT end;
	//   
	if(objects[2]->alive > 0)
	{
		x = objects[2]->pos.x;
		y = objects[2]->pos.y;

        pen.CreatePen(PS_SOLID, 1, RGB(0, 0, 255));
        def_pen = dc.SelectObject(&pen);
        br.CreateSolidBrush(RGB(0, 0, 128));
		def_br = dc.SelectObject(&br);

		rect.top = LONG( GetY(y)-4 );
		rect.bottom = LONG( GetY(y) + 4 );
		rect.left = LONG( GetX(x)-4 );
		rect.right = LONG( GetX(x)+4 );

		dc.Ellipse(&rect);

		dc.SelectObject(def_br);
		br.DeleteObject();
		//   
		r = Zrk1Multi.maxR;

		rect.top = LONG( GetY(y - r) );
		rect.bottom = LONG( GetY(y + r) );
		rect.left = LONG( GetX(x - r) );
		rect.right = LONG( GetX(x + r) );

		a = ((ZRK*)objects[2])->alpha;
		g = Zrk1Multi.gamma * PI / 360.;
		
		start.x = LONG( GetX(x)+10*cos(a - g) );
		start.y = LONG( GetY(y)-10*sin(a - g) );
		end.x = LONG( GetX(x)+10*cos(a + g) );
		end.y = LONG( GetY(y)-10*sin(a + g) );

		// .   ,  ,   - 
        if (((ZRK*)objects[2])->num_rockets > 0)
            br.CreateSolidBrush(RGB(0, 0, 128));
        else
            br.CreateSolidBrush(RGB(0, 0, 50));
		
		//pen.CreatePen(PS_SOLID, 1, RGB(255, 0, 0));
		//def_br = dc.SelectObject(&br);
		//dc.SelectObject(&pen);
		dc.Pie(&rect, start, end);
		dc.SelectObject(def_br);
		br.DeleteObject();
		dc.SelectObject(def_pen);
		pen.DeleteObject();
	}
	//pen.DeleteObject();
	//  
	if(objects[3]->alive > 0)
	{
		x = objects[3]->pos.x;
		y = objects[3]->pos.y;

		rect.top = LONG( GetY(y)-4 );
		rect.bottom = LONG( GetY(y) + 4 );
		rect.left = LONG( GetX(x)-4 );
		rect.right = LONG( GetX(x)+4 );

        pen.CreatePen(PS_SOLID, 1, RGB(0, 0, 255));
        def_pen = dc.SelectObject(&pen);
        br.CreateSolidBrush(RGB(0, 0, 128));
		def_br = dc.SelectObject(&br);
		dc.Ellipse(&rect);
		dc.SelectObject(def_br);
		br.DeleteObject();
		//   
		r = Zrk2Single.maxR;

		rect.top = LONG( GetY(y - r) );
		rect.bottom = LONG( GetY(y + r) );
		rect.left = LONG( GetX(x - r) );
		rect.right = LONG( GetX(x + r) );

		a = ((ZRK*)objects[3])->alpha;
		g = Zrk2Single.gamma * PI / 360.;

		start.x = LONG( GetX(x)+10*cos(a - g) );
		start.y = LONG( GetY(y)-10*sin(a - g) );
		end.x = LONG( GetX(x)+10*cos(a + g) );
		end.y = LONG( GetY(y)-10*sin(a + g) );
		// .   ,  ,   - 
        if (((ZRK*)objects[3])->num_rockets > 0)
            br.CreateSolidBrush(RGB(0, 0, 128));
        else
            br.CreateSolidBrush(RGB(0, 0, 50));
		def_br = dc.SelectObject(&br);
		dc.Pie(&rect, start, end);
		dc.SelectObject(def_br);
		br.DeleteObject();
		dc.SelectObject(def_pen);
        pen.DeleteObject();
	}
}

void DrawAirdroms(CDC &dc)
{
	//    ! 
	//..     ...
	//      
	//   objetcs -  
	//  
	RECT rt;
	CPen pen;
	CBrush brush;
	CPen* def_pen;
	CBrush* def_brush;
	//  
	pen.CreatePen(PS_SOLID, 1, RGB(255, 0, 0));
	brush.CreateSolidBrush(RGB(100, 0, 0));
	def_pen = dc.SelectObject(&pen);
	def_brush = dc.SelectObject(&brush);
	Objects::iterator ob = objects.end();
	ob--;
	AtackAirdrom* pAir = (AtackAirdrom*)*ob;
	double x = pAir->baza_b.x;
	double y = pAir->baza_b.y;
	rt.left = LONG( GetX(x) ) - 4;
	rt.right = LONG( GetX(x) ) + 4;
	rt.top = LONG( GetY(y) ) - 4;
	rt.bottom = LONG( GetY(y) ) + 4;
	dc.Ellipse(&rt);
	//   
	x = pAir->baza_f.x;
	y = pAir->baza_f.y;
	rt.left = LONG( GetX(x) ) - 3;
	rt.right = LONG( GetX(x) ) + 3;
	rt.top = LONG( GetY(y) ) - 3;
	rt.bottom = LONG( GetY(y) ) + 3;
	dc.Ellipse(&rt);
    dc.SelectObject(def_brush);
    dc.SelectObject(def_pen);
    pen.DeleteObject();
    brush.DeleteObject();
	//  
	ob--;
	Airdrom* pAr = (Airdrom*)*ob;
	if(pAr->alive > 0)
	{
		x = pAr->pos.x;
		y = pAr->pos.y;
		rt.left = LONG( GetX(x) ) - 4;
		rt.right = LONG( GetX(x) ) + 4;
		rt.top = LONG( GetY(y) ) - 4;
		rt.bottom = LONG( GetY(y) ) + 4;
		pen.CreatePen(PS_SOLID, 1, RGB(0, 0, 255));
		brush.CreateSolidBrush(RGB(0, 0, 128));
		def_pen = dc.SelectObject(&pen);
		def_brush = dc.SelectObject(&brush);
		dc.Ellipse(&rt);
        dc.SelectObject(def_brush);
        dc.SelectObject(def_pen);
        pen.DeleteObject();
        brush.DeleteObject();
	}
}

void DrawX(CDC &dc)
{
	//CPen pen;
	//CPen* def_pen;
	//int x;
	//pen.CreatePen(PS_SOLID, 1, RGB(0, 128, 0));
	//def_pen = dc.SelectObject(&pen);
	//dc.MoveTo( int( GetX(-interval_x) ), int( GetY(0)) );
	//dc.LineTo( int( GetX(interval_x) ), int( GetY(0)) );
	//x = 100;
	//while(x < interval_x)
	//{
	//	dc.MoveTo( int( GetX(-x) ), int( GetY(0)-2) );
	//	dc.LineTo( int( GetX(-x) ), int( GetY(0)+2) );
	//	dc.MoveTo( int( GetX(x) ), int( GetY(0)-2) );
	//	dc.LineTo( int( GetX(x) ), int( GetY(0)+2) );
	//	x+=100;
	//}
	//dc.SelectObject(def_pen);
	//pen.DeleteObject();
}

void DrawY(CDC &dc)
{
	//CPen pen;
	//CPen* def_pen;
	//int y;
	//pen.CreatePen(PS_SOLID, 1, RGB(0, 128, 0));
	//def_pen = dc.SelectObject(&pen);
	//dc.MoveTo( int( GetX(0) ), int( GetY(-interval_y) ) );
	//dc.LineTo( int( GetX(0) ), int( GetY(interval_y) ) );
	//y = 100;
	//while(y < interval_y)
	//{
	//	dc.MoveTo( int( GetX(0) )-2, int( GetY(-y) ) );
	//	dc.LineTo( int( GetX(0) )+2, int( GetY(-y) ) );
	//	dc.MoveTo( int( GetX(0) )-2, int( GetY(y) ) );
	//	dc.LineTo( int( GetX(0) )+2, int( GetY(y) ) );
	//	y+=100;
	//}
	//dc.SelectObject(def_pen);
	//pen.DeleteObject();
}

void DrawGrid(CDC &dc)
{
	//       
	//       -  
	//     
	DrawX(dc);
	DrawY(dc);
}

void DrawPlane(CDC &dc, PlaneList::iterator p)
{
	if (p->alive<=0) return; 
	CBrush br, *def_br;
	CPen pen, *def_pen;
	RECT rect;
	int s=2;
	if(p->type)s=3;
	if((abs(p->pos.x) < interval_x)&&
		(abs(p->pos.y) < interval_y))
	{
		rect.left = LONG( GetX(p->pos.x)-s );
		rect.right = LONG( GetX(p->pos.x)+s );
		rect.top = LONG( GetY(p->pos.y)-s );
		rect.bottom = LONG( GetY(p->pos.y)+s );
		if(p->IsOur())
		{
			br.CreateSolidBrush(RGB(0, 0, 255));
			pen.CreatePen(PS_SOLID, 1, RGB(0, 200, 255));
		}
		else
		{
			if((p->manevr > 0) && (p->manevr < 3))
				br.CreateSolidBrush(RGB(0, 0, 255));
			else 
                br.CreateSolidBrush(RGB(200, 200, 0));
			pen.CreatePen(PS_SOLID, 1, RGB(255, 0, 0));
		}
		def_br = dc.SelectObject(&br);
		def_pen = dc.SelectObject(&pen);
		dc.Ellipse(&rect);
		dc.SelectObject(def_pen);
        dc.SelectObject(def_br);
		br.DeleteObject();
		pen.DeleteObject();
	}
}

void DrawRocket(CDC &dc, RocketList::iterator p)
{
	if((abs(p->pos.x) < interval_x)&&
		(abs(p->pos.y) < interval_y))
		dc.SetPixel( int( GetX(p->pos.x) ), int( GetY(p->pos.y) ), RGB(0, 255, 255));
}

void DrawPlanes(CDC &dc)
{
	PlaneList::iterator p = planes.begin();
	while(p != planes.end())DrawPlane(dc, p++);
}

void DrawRockets(CDC &dc)
{
	RocketList::iterator p = rockets.begin();
	while(p != rockets.end())DrawRocket(dc, p++);
}


void Visualize(CDC& dc, RECT w)
{
	DrawRegion(dc, w);
	DrawRLS(dc);
	DrawZRK(dc);
	DrawObject(dc);
	DrawAirdroms(dc);
	DrawGrid(dc);
	DrawPlanes(dc);
	DrawRockets(dc);
}

UINT VisualizeProc(LPVOID p)
{
	VisualParam* pParam = (VisualParam*)p;
	if (pParam == NULL)
		return 1;   // if pParam is not valid
	Visualize(*pParam->dc, *pParam->rt);
    return 0;   // thread completed successfully

}