#include "stdafx.h"
#include "presets.h"

double TIME;
double dt;
PlaneList planes;
RocketList rockets;
bool m_zrk_alive;
bool s_zrk_alive;
bool rls_alive;
bool air_alive;
bool obj_alive;
bool all_our_planes_down;
bool all_planes_down;
bool zrk_empty;
int our_down;   //        !
int att_down;   //        !
int iter;
int delay;
int object_bombed;
double total_time;

int end_by_rls_destroy;
int end_by_obj_destroy;
int end_by_deffenders_destroy;
int end_by_attackers_destroy;


//     
//       
//     ...  
//       
PlaneList targets_for_cr;
double* significanty;
Lives life;
ActiveMeans am;
Objects objects;
CWnd* h_Dlg;

Vector3D m_zrk_pos;
Vector3D s_zrk_pos;
Vector3D f_air_pos;
Vector3D b_air_pos;
Vector3D air_pos;
Vector3D obj_pos;
Vector3D rls_pos;



void NewPlane(Plane pl)
{
	planes.push_back(pl);
}

void NewRocket(Rocket rt)
{
	rockets.push_back(rt);
}

Plane* FindPlane(int id)
{
	PlaneList::iterator p = planes.begin();
	while(p != planes.end())
		if(p->GetId() == id)return &(*p);
		else p++;
	return NULL;
}

PlaneList* GetPlanes()
{
	return &planes;
}

RocketList* GetRockets()
{
	return &rockets;
}

double Random()
{
	//   (0, 1)
	return (double)rand()/RAND_MAX;
}

double Norm(double sigma)
{
	//  
	//sigma -   (   )
	//    
	double e = 0;
	int n = 17;
	for(int i = 0; i < n; i++) e += Random();
	return sqrt(12.0/n) * (e - n/2.0)*sigma;
}

Vector3D Norm3D(Vector3D sigma)
{
	//      
	//  ...
	Vector3D err;
	err.x = Norm(sigma.x);
	err.y = Norm(sigma.y);
	err.z = Norm(sigma.z);
	return err;
}

void Print(const char * msg)
{
	h_Dlg->SendDlgItemMessage(IDC_LIST, LB_ADDSTRING, 
		0, (LPARAM)msg);
	CListBox* pList = (CListBox*)h_Dlg->GetDlgItem(IDC_LIST);
	int nCount = pList->GetCount();
	pList->SetCurSel(nCount-1);
}

void Init()
{
	dt = 2;
	srand( (unsigned)time( NULL ) );
	TIME = 0;

	m_zrk_alive = 1;
	s_zrk_alive = 1;
	rls_alive = 1;
	air_alive = 1;
	obj_alive = 1;
	all_planes_down = 0;
    all_our_planes_down = 0;
	zrk_empty = 0;

	significanty = new double[5];
	significanty[0] = positions_presets[CUR_PRESET].priorities.obj;//OBJECT
	significanty[1] = positions_presets[CUR_PRESET].priorities.rls;//RLS
	significanty[2] = positions_presets[CUR_PRESET].priorities.mzrk;//MULTI ZRK
	significanty[3] = positions_presets[CUR_PRESET].priorities.szrk;//SINGLE ZRK
	significanty[4] = positions_presets[CUR_PRESET].priorities.air;//AIRDROM

	//life.push_back(500.0);//OBJECT
	//life.push_back(200.0);//RLS
	//life.push_back(150.0);//MULTI ZRK
	//life.push_back(150.0);//SINGLE ZRK
	//life.push_back(200.0);//AIRDROM

	//m_zrk_pos = Vector3D(10, 30, 0);
	//s_zrk_pos = Vector3D(-30, -50, 0);
	//f_air_pos = Vector3D(-400, 80, 0);
	//b_air_pos = Vector3D(-400, -40, 0);
	//air_pos = Vector3D(30, -60, 0);
	//obj_pos = Vector3D(30, 20, 0);
	//rls_pos = Vector3D(0, 0, 0);
}

bool IsEnd()
{
	if (rls_alive == false)
    {
        end_by_rls_destroy++;
        return true;
    }
	if (obj_alive == false)
    {
        end_by_obj_destroy++;
        return true;
    }
	if (!m_zrk_alive && !s_zrk_alive && (all_our_planes_down || !air_alive))
    {
        end_by_deffenders_destroy++;
        return true;
    }
	if (all_planes_down)
    {
        end_by_attackers_destroy++;
        return true;
    }
	//if (zrk_empty)
 //       return true;
	return false;
}

void ZrkDestroyed(int c)
{
	if(c > 1)m_zrk_alive = false;
	else s_zrk_alive = false;

	char *res_str = new char[256];
	sprintf(res_str, "[ %g ]: %i-  !", 
		TIME, c);
	Print(res_str);
	delete [] res_str;
}

void ObjectDestroyed()
{
	obj_alive = false;

	char *res_str = new char[256];
	sprintf(res_str, "[ %g ]:   !", TIME);
	Print(res_str);
	delete [] res_str;
}

void AirdromDestroyed()
{
	air_alive = false;
	char *res_str = new char[256];
	sprintf(res_str, "[ %g ]:  !", TIME);
	Print(res_str);
}

void RlsDestroyed()
{
	rls_alive = false;
	char *res_str = new char[256];
	sprintf(res_str, "[ %g ]:  !", TIME);
	Print(res_str);
	delete [] res_str;
}

void Lost(Plane *pl)
{
	char *res_str = new char[256];
	sprintf(res_str,"[ %g ]:   =%i    !", TIME, pl->GetId());
	Print(res_str);
	delete [] res_str;
	// ,  
	//    
	pl->undat = 0;
}

void Ukaz(int who, Plane* target, Vector3D err)
{
	switch(who)
	{
	case 1:am[0]->Ukaz(target, err);
		break;
	case 2:am[1]->Ukaz(target, err);
		break;
	case 3:am[2]->Ukaz(target, err);
		break;
	}
}

void UpdateStats()
{
	PlaneList::iterator pl = planes.begin(), ptemp;
	while( pl != planes.end() )
	{
		if( !(pl->IsAlive()) )
		{
			if( pl->alive > -100 )
				if( pl->IsOur() ) 
                    our_down++;
				else 
                    att_down++;
			pl->alive = -1000;
//			if(pl->alive==-2) {
//				
//			/*	char *res_str = new char[256];
//					sprintf(res_str,"[ %g ]: Plane with id=%i removed!",TIME,pl->GetId());
//					Print(res_str);
//					delete [] res_str;
//*/
//				ptemp = pl;
//				pl++;
//				//planes.erase(ptemp);
//			}
		}
		pl++;
	}
	RocketList::iterator rt = rockets.begin();
	while(rt != rockets.end())
		if(!rt->IsAlive())rt = rockets.erase(rt);
		else rt++;
}

void EndModel()
{
	CString str;
	Print("STATISTICS:");
	double to_object = (double)object_bombed / iter;
	str.Format("     : %5.2f", (double)to_object); 
	Print(str);
	str.Format("    : %5.2f", (double)our_down / iter);
	Print(str);
	str.Format("    : %5.2f", (double)att_down / iter);
	Print(str);
	str.Format("  : %i hours, %i min, %i sec", 
		(int)( total_time / (3600*iter)), 
		((int)( total_time / (60*iter)) % 60),
		((int)( total_time / (iter)) % 60));
	Print(str);

    str.Format("   :   : %d, : %d, : %d, : %d", end_by_rls_destroy, end_by_obj_destroy, end_by_deffenders_destroy, end_by_attackers_destroy);
    Print(str);

    life.clear();
}

void DrawLives(CWinWarDlg *pDlg)
{
	pDlg->SetDlgItemInt(IDC_OBJECT, UINT( objects[0]->alive ), true);
	pDlg->SetDlgItemInt(IDC_RLS, UINT( objects[1]->alive ), true);
	pDlg->SetDlgItemInt(IDC_ZRK1, UINT( am[1]->alive ), true);
	pDlg->SetDlgItemInt(IDC_ZRK6, UINT( am[0]->alive ), true);
	pDlg->SetDlgItemInt(IDC_AIRDROM, UINT( am[2]->alive ), true);
}

void OneIterModel(CWinWarDlg *pDlg)
{
	Init();
	Object* o = new Object();
	o->Init();
	Object obj(obj_pos, significanty[0], life[0]);
	objects.push_back(&obj);
	RLS rls(significanty[1], life[1]);
	objects.push_back(&rls);
	ZRK m_zrk(m_zrk_pos, Zrk1Multi, significanty[2], life[2]);
	am.push_back(&m_zrk);
	objects.push_back(&m_zrk);
	ZRK s_zrk(s_zrk_pos, Zrk2Single, significanty[3], life[3]);
	am.push_back(&s_zrk);
	objects.push_back(&s_zrk);
	Airdrom air(air_pos, significanty[4], life[4]);
	am.push_back(&air);
	objects.push_back(&air);
	AtackAirdrom enemy_air(f_air_pos, b_air_pos);
	objects.push_back(&enemy_air);

	RECT w;
	pDlg->GetClientRect(&w);

	CClientDC dc(pDlg);
	CDC cdc;
	cdc.CreateCompatibleDC(&dc);
	CBitmap *bmp = new CBitmap();
    CBitmap *old_bmp;
	bmp->CreateCompatibleBitmap(&dc, w.right - btn_width, 
									w.bottom - lst_height);
	old_bmp = cdc.SelectObject(bmp);
	while(!IsEnd())
	{
		enemy_air.attack(&planes, &rockets);
		rls.Attack();
		m_zrk.NextTurn();
		s_zrk.NextTurn();
		air.attack(&planes, &rockets);
		UpdateStats();
		Visualize(cdc, w);
		dc.BitBlt(0, 0, w.right - btn_width, 
						w.bottom - lst_height, &cdc, 0, 0, SRCCOPY);
		DrawLives(pDlg);
		TIME += dt;
		Sleep(delay);
	}
	total_time += TIME;
	Print("End iteration !");
    cdc.SelectObject(old_bmp);
	//dc.DeleteDC();
	objects.clear();
	am.clear();
	planes.clear();
	rockets.clear();
}

UINT StartModel(LPVOID pVoid)
{
	CString str; 
	int N = iter;
	CWinWarDlg *pDlg = (CWinWarDlg*)pVoid;
	if(pDlg == NULL)return 1;

	object_bombed = 0;
	our_down = 0;
	att_down = 0;
	total_time = 0;

    end_by_rls_destroy = 0;
    end_by_obj_destroy = 0;
    end_by_deffenders_destroy = 0;
    end_by_attackers_destroy = 0;

	while(N--)OneIterModel(pDlg);
	EndModel();
	return 0;
}