#include "StdAfx.h"

int Object::count;

void Object::Init()
{
	count = 0;
}

Object::Object(void)
{
	pos.x = pos.y = pos.z = 0;
	alive = true;
	sign = 1;
	id = count++;
}

Object::Object(double s)
{
	pos.x = pos.y = pos.z = 0;
	alive = 100.0;
	sign = 1;
	id = count++;
}

Object::Object(double s, double l)
{
	pos.x = pos.y = pos.z = 0;
	alive = l;
	sign = 1;
	id = count++;
}

Object::Object(Vector3D p)
{
	pos = p;
	alive = 1.0;
	sign = 1;
	id = count++;
}

Object::Object(Vector3D p, double l)
{
	pos = p;
	alive = l;
	sign = 1;
	id = count++;
}

Object::Object(Vector3D p, double s, double l)
{
	pos = p;
	alive = l;
	sign = 1;
	id = count++;
}

Object::~Object(void)
{
}

double Object::IsAlive()
{
	return alive > 0 ? 1 : 0;
}

double Object::GetSign()
{
	return sign;
}

void Object::Destroy()
{
	alive = 0;
}

int Object::GetId()
{
	return id;
}